cPosition = { name = "position" }
function cPosition.new(o) 
	return { 
		x = o.x or 0, 
		y = o.y or 0, 
		z = o.z or 0, 
		rot = o.rot or 0,
		outOfBounds = o.outOfBounds
	} 
end

cDrawable = { name = "drawable" }
function cDrawable.new(o)
	local v = true
	if o.visible == false then v = false end

	return {
		image = o.image,
		shape = o.shape,
		width = o.width or win.x,
		height = o.height or win.y,
		color = o.color or { 255, 255, 255 },
		radius = o.radius,
		frames = o.frames or 1,
		currentFrame = o.currentFrame or 1,
		visible = v
	}
end

cAnimation = { name = "animation" }
function cAnimation.new(o)
	return {
		fps = o.fps or 8,
		startFrame = o.startFrame or 1,
		endFrame = o.endFrame or 8,
		mode = o.mode or "loop",
		direction = o.direction or 1,
		elapsedTime = o.elapsedTime or 0
	}
end

cMoveable = { name = "movable"}
function cMoveable.new(o)
	return {
		direction = o.direction,
		speed = o.speed
	}
end

cText = { name = "text", defaultFont = "slkscr.ttf", defaultSize = 16 }
function cText.new(o)
	local v = true
	if o.visible == false then v = false end

	return { 
		str = o.str or "Missing", 
		size = o.size or cText.defaultSize, 
		font = o.font or cText.defaultFont, 
		color = o.color or { 255, 255, 255 }, 
		align = o.align or "center",
		valign = o.valign or "top",
		shadowOffset = o.shadowOffset or 0,
		shadowColor = o.shadowColor or { 0, 0, 0, 88 },
		maxWidth = o.maxWidth or 0,
		visible = v
	}
end

cGui = { name = "gui" }
function cGui.new(o)
	return {
		hover = o.hover or {},
		shortcut = o.shortcut
	}
end

cEventCallback = { name = "eventCallback" }
function cEventCallback.new(o)
	return { 
		func = o.func,
		data = o.data or {}
	}
end

cToggle = { name = "toggle" }
function cToggle.new(o)
	return { on = o.on or false }
end

cMorph = { name = "morph" }
function cMorph.new(o)
	return {
		startPos = o.startPos,
		endPos = o.endPos or o.startPos,
		startSize = o.startSize,
		endSize = o.endSize or o.startSize,
		startColor = o.startColor,
		endColor = o.endColor or o.startColor,
		totalTime = o.totalTime,
		elapsedTime = 0
	}
end

cTimeout = { name = "timeout" }
function cTimeout.new(o)
	return {
		timer = o.timer,
		removeAfter = o.removeAfter or false,
		restartFunc = o.restartFunc
	}
end