factory = {}
factory.fonts = {}
factory.sounds = {}
factory.images = {}
factory.music = {}
factory.folders = { fonts = "res/fonts/", images = "res/images/", sounds = "res/sounds/", music = "res/music/" }

function factory:getFont(file, size)
	local fileId = file .. size

	if not self.fonts[fileId] then
		self.fonts[fileId] = love.graphics.newFont(self.folders.fonts .. file, size)
	end
	
	return self.fonts[fileId]
end

function factory:getImage(file)
	if not self.images[file] then
		self.images[file] = love.graphics.newImage(self.folders.images .. file)
	end
	
	return self.images[file]
end

function factory:getMusic(file)
	if not self.music[file] then
		self.music[file] = love.audio.newSource(self.folders.music .. file)
	end
	
	return self.music[file]
end