guisys = {}
guisys.mouseEvents = {}
guisys.keyEvents = {}

function guisys.onMouseEvent(button, x, y, down)
	if button == "l" and not down then
		table.insert(guisys.mouseEvents, { x = x, y = y })
	end
end

function guisys.onKeyEvent(key, down)
	if not down then
		table.insert(guisys.keyEvents, key)
	end
end

guisys.keyEventId = inputmgr:addKeyEvent(guisys.onKeyEvent)
guisys.mouseEventId = inputmgr:addMouseEvent(guisys.onMouseEvent)

function guisys:update(dt)
	local entities = entitymgr:getEntities(cGui.name)
	
	for i, eId in ipairs(entities) do
		local gui = entitymgr:getComponent(eId, cGui.name)
		local pos = entitymgr:getComponent(eId, cPosition.name)
		local text = entitymgr:getComponent(eId, cText.name)
		local draw = entitymgr:getComponent(eId, cDrawable.name)
		
		if gui then	
			for j, w in ipairs(self.keyEvents) do
				if gui.shortcut == w then self:handleEvents(eId) end
			end
			
			if text and text.visible then self:handleText(eId, gui, text, pos)
			elseif draw then
				--  TODO
			end
		end
	end
	
	self.keyEvents = {}
	self.mouseEvents = {}
end

function guisys:handleText(eId, gui, text, pos)
	if not pos then return end
	
	local mx, my = inputmgr:getMousePosition()
	local x1, y1, x2, y2
	x1, y1, x2, y2 = drawsys:getTextPositionAndSize(text, pos)
	x2 = x1 + x2
	y2 = y1 + y2
	
	-- hover
	if x1 <= mx and mx <= x2 and y1 <= my and my <= y2 then
		if gui.hover.color then
			if not gui.hover.oldColor then gui.hover.oldColor = text.color end
			text.color = gui.hover.color
		end
	elseif gui.hover.oldColor then 
		text.color = gui.hover.oldColor 
		gui.hover.oldColor = nil
	end
	
	-- click
	for i, v in ipairs(self.mouseEvents) do
		if x1 <= v.x and v.x <= x2 and y1 <= v.y and v.y <= y2 then
			self:handleEvents(eId)
		end
	end
end

function guisys:handleEvents(eId)
	local event = entitymgr:getComponent(eId, cEventCallback.name) 
	if event then 
		event.func(eId, event.data) 
	end
end