inputmgr = {}
inputmgr.keyEvents = {}
inputmgr.mouseEvents = {}
local keyEventCount = 0
local mouseEventCount = 0

function inputmgr:nextKeyEventId()
	keyEventCount = keyEventCount + 1
	return keyEventCount
end

function inputmgr:nextMouseEventId()
	mouseEventCount = mouseEventCount + 1
	return mouseEventCount
end

function inputmgr:addKeyEvent(func, eventId)
	local eventId = eventId or self:nextKeyEventId()
	self.keyEvents[eventId] = func
	return eventId
end

function inputmgr:addMouseEvent(func, eventId)
	local eventId = eventId or self:nextMouseEventId()
	self.mouseEvents[eventId] = func
	return eventId
end

function inputmgr:isKeyDown(key)
	return love.keyboard.isDown(key)
end

function inputmgr:isMouseButtonDown(btn)
	return love.mouse.isDown(btn)
end

function inputmgr:getMousePosition()
	return love.mouse.getX(), love.mouse.getY()
end

function love.keypressed(key, unicode)
	for i = 1, keyEventCount do
		if inputmgr.keyEvents[i] then
			inputmgr.keyEvents[i](key, true)
		end
	end
end

function love.keyreleased(key, unicode)
	for i = 1, keyEventCount do
		if inputmgr.keyEvents[i] then
			inputmgr.keyEvents[i](key, false)
		end
	end
end

function love.mousepressed(x, y, button)
	for i = 1, mouseEventCount do
		if inputmgr.mouseEvents[i] then
			inputmgr.mouseEvents[i](button, x, y, true)
		end
	end
end

function love.mousereleased(x, y, button)
	for i = 1, mouseEventCount do
		if inputmgr.mouseEvents[i] then
			inputmgr.mouseEvents[i](button, x, y, false)
		end
	end
end