scenemgr = {}
scenemgr.scenes = {}
scenemgr.current = nil

function scenemgr:load()
	local scenes = require("scenes/scenes")
	for i, v in ipairs(scenes) do
		self.scenes[v] = require("scenes/" .. v)
	end
	
	self:open(scenes.default)
end

function scenemgr:open(scene)
	if self.current then
		self.scenes[self.current]:close(scenemgr.onClosed, scene)
	end

	scenemgr.current = scene
	scenemgr.scenes[scenemgr.current]:open()
end

function scenemgr:pause()
	if self.current then self.scenes[self.current]:pause() end
end

function scenemgr:unpause()
	if self.current then self.scenes[self.current]:unpause() end
end

function scenemgr:update(dt)
	if self.current then self.scenes[self.current]:update(dt) end
end

function scenemgr:draw()
	if self.current then self.scenes[self.current]:draw() end
end