local s = {}
s.level = 1

function s:open()
	if not self.entities then
		self:loadLevel(self.level)

		entitymgr:addEntity{
			{ name = cGui.name, data = cGui.new{ shortcut = "escape" } },
			{ name = cEventCallback.name, data = cEventCallback.new{ func = function () scenemgr:open("menu") end } }
		}
	else
		entitymgr:addEntities(self.entities)
	end
end

function s:close()
	self.entities = entitymgr:removeAll()
end

function s:update(dt)
	positionsys:update(dt)
	guisys:update(dt)
	animationsys:update(dt)
end

function s:draw()
	drawsys:draw()
end

function s:pause()

end

function s:unpause()

end

function s:loadLevel(level)
	entitymgr:removeAll()
	self.entities = {}
end

return s