timersys = {}

function timersys:update(dt)
	local entities = entitymgr:getEntities(cTimeout.name)
	
	for i, eId in ipairs(entities) do
		local timeout = entitymgr:getComponent(eId, cTimeout.name)
		
		timeout.timer = timeout.timer - dt
		
		if timeout.timer <= 0 then
			local event = entitymgr:getComponent(eId, cEventCallback.name)
			if event then
				event.func(eId, event.data)
			end
			
			if not timeout.removeAfter then
				if timeout.restartFunc then	timeout.timer = timeout.restartFunc() end
			else
				entitymgr:removeComponent(eId, cTimeout.name)
			end
		end
	end
end